#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    float float_eq_const_0_0;
    float float_eq_const_1_0;
    float float_eq_const_2_0;
    float float_eq_const_3_0;
    float float_eq_const_4_0;
    float float_eq_const_5_0;
    float float_eq_const_6_0;
    float float_eq_const_7_0;
    float float_eq_const_8_0;
    float float_eq_const_9_0;

    if (size < 40)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&float_eq_const_0_0, &data[i], 4);
    i += 4;
    memcpy(&float_eq_const_1_0, &data[i], 4);
    i += 4;
    memcpy(&float_eq_const_2_0, &data[i], 4);
    i += 4;
    memcpy(&float_eq_const_3_0, &data[i], 4);
    i += 4;
    memcpy(&float_eq_const_4_0, &data[i], 4);
    i += 4;
    memcpy(&float_eq_const_5_0, &data[i], 4);
    i += 4;
    memcpy(&float_eq_const_6_0, &data[i], 4);
    i += 4;
    memcpy(&float_eq_const_7_0, &data[i], 4);
    i += 4;
    memcpy(&float_eq_const_8_0, &data[i], 4);
    i += 4;
    memcpy(&float_eq_const_9_0, &data[i], 4);
    i += 4;


    if (float_eq_const_0_0 == -0.114970915f)
    if (float_eq_const_1_0 == 3.0677486E-20f)
    if (float_eq_const_2_0 == 2.8101208E18f)
    if (float_eq_const_3_0 == 1.1562561E30f)
    if (float_eq_const_4_0 == 6.1592264E13f)
    if (float_eq_const_5_0 == -563.9252f)
    if (float_eq_const_6_0 == 1.3088103E-27f)
    if (float_eq_const_7_0 == 1.0615744E32f)
    if (float_eq_const_8_0 == -1.0672018E-37f)
    if (float_eq_const_9_0 == 3.3338356E-4f)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
